regina::NTorusBundle Class Reference
Standard 3-Manifolds

Represents a torus bundle over the circle. More...

`#include <manifold/ntorusbundle.h>`

Inheritance diagram for regina::NTorusBundle:

## Public Member Functions

| NTorusBundle ()
| Creates a new trivial torus bundle over the circle. More...
| NTorusBundle (const NMatrix2 &newMonodromy)
| Creates a new torus bundle over the circle using the given monodromy. More...
| NTorusBundle (long mon00, long mon01, long mon10, long mon11)
| Creates a new torus bundle over the circle using the given monodromy. More...
| NTorusBundle (const NTorusBundle &cloneMe)
| Creates a clone of the given torus bundle. More...
const NMatrix2 & | getMonodromy () const
| Returns the monodromy describing how the upper and lower torus boundaries are identified. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
Public Member Functions inherited from regina::NManifold
virtual | ~NManifold ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a torus bundle over the circle.

This is expressed as the product of the torus and the interval, with the two torus boundaries identified according to some specified monodromy.

The monodromy is described by a 2-by-2 matrix M as follows. Let a and b be generating curves of the upper torus boundary, and let p and q be the corresponding curves on the lower torus boundary (so that a and p are parallel and b and q are parallel). Then we identify the torus boundaries so that, in additive terms:

        [a]       [p]
        [ ] = M * [ ]
        [b]       [q]

All optional NManifold routines except for construct() are implemented for this class.

Test:
  Included in the test suite.

Todo:
  Feature: Implement the == operator for finding conjugate and inverse matrices.

## Constructor & Destructor Documentation

regina::NTorusBundle::NTorusBundle | ( |  | ) |

inline

Creates a new trivial torus bundle over the circle.

In other words, this routine creates a torus bundle with the identity monodromy.

regina::NTorusBundle::NTorusBundle | ( | const NMatrix2 & | newMonodromy | ) |

inline

Creates a new torus bundle over the circle using the given monodromy.

Precondition
  The given matrix has determinant +1 or -1.

Parameters

  newMonodromy | describes precisely how the upper and lower torus boundaries are identified. See the class notes for details.

regina::NTorusBundle::NTorusBundle | ( | long | mon00,
|  | long | mon01,
|  | long | mon10,
|  | long | mon11
| ) |  |

inline

Creates a new torus bundle over the circle using the given monodromy.

The four elements of the monodromy matrix are passed separately. They combine to give the full monodromy matrix M as follows:

              [ mon00  mon01 ]
        M  =  [              ]
              [ mon10  mon11 ]

Precondition
  The monodromy matrix formed from the given parameters has determinant +1 or -1.

Parameters

  mon00 | the (0,0) element of the monodromy matrix.
  mon01 | the (0,1) element of the monodromy matrix.
  mon10 | the (1,0) element of the monodromy matrix.
  mon11 | the (1,1) element of the monodromy matrix.

regina::NTorusBundle::NTorusBundle | ( | const NTorusBundle & | cloneMe | ) |

inline

Creates a clone of the given torus bundle.

Parameters

  cloneMe | the torus bundle to clone.

## Member Function Documentation

NAbelianGroup* regina::NTorusBundle::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

const NMatrix2 & regina::NTorusBundle::getMonodromy | ( |  | ) | const

inline

Returns the monodromy describing how the upper and lower torus boundaries are identified.

See the class notes for details.

Returns
  the monodromy for this torus bundle.

std::ostream& regina::NTorusBundle::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream& regina::NTorusBundle::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

The documentation for this class was generated from the following file:

- manifold/ntorusbundle.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).